using System;
using Syntriax.Engine.Core;
using Syntriax.Engine.Core.Abstract;

namespace Syntriax.Engine.Physics2D.Abstract;

public interface ICollider2D : IBehaviour, IAssignableTransform
{
    Action<ICollider2D, ICollider2D>? OnCollisionPreResolve { get; set; }
    Action<ICollider2D, ICollider2D>? OnCollisionResolved { get; set; }

    IRigidBody2D? RigidBody2D { get; }

    void Recalculate();
}
